#pragma once

namespace test
{
namespace data
{
    namespace phonemes
    {
        static std::vector<std::string> Affricate = 
            { "ch", "dg", "j" };

        static std::vector<std::string> Alveolar = 
            { "d", "l", "n", "r", "s", "t", "z" }; 

        static std::vector<std::string> Bilabial = 
            { "b", "m", "p" }; 

        static std::vector<std::string> BilabialStop = 
            { "b", "p" }; 

        static std::vector<std::string> Complex = 
            { "sch", "thr" }; 

        static std::vector<std::string> Consonant = 
            { "b", "c", "d", "f", "g", "h", "j", "k", "l", "m", "n", "p", "r", 
              "s", "t", "v", "z" }; 

        static std::vector<std::string> DoubleConsonant = 
            { "bb", "dd", "ff", "ll", "mm", "nn", "rr", "ss", "ss", "tt" };

        static std::vector<std::string> DoubleGlide = 
            { "wy" };

        static std::vector<std::string> EndingNasal = 
            { "g", "ng", "r" };

        static std::vector<std::string> Fricative = 
            { "ch", "f", "ph", "s", "sh", "th", "v", "z" };

        static std::vector<std::string> Glide = 
            { "w", "y" };

        static std::vector<std::string> Glottal = 
            { "h" }; 

        static std::vector<std::string> Liquid = 
            { "l", "r" };

        static std::vector<std::string> MidConsonant = 
            { "ct", "dr", "dw", "ft", "mk", "nd", "ndr", "nf", "nj", "nk", "ns", 
              "nt", "ny", "pr", "ps", "rd", "rg", "rk", "rm", "rn", "rz", "sl", 
              "st", "stl", "wl", "ck" };

        static std::vector<std::string> Nasal = 
            { "m", "n" };

        static std::vector<std::string> Palatal = 
            { "ch", "dg", "s", "j", "sh", "y" }; 

        static std::vector<std::string> Stop = 
            { "b", "d", "g", "k", "p", "t" };

        static std::vector<std::string> Velar = 
            { "g", "k", "ng", "w" }; 

        static std::vector<std::string> Dipthong = 
            { "ay", "ea", "ee", "ei", "oa", "oe", "ou", "ow", "oy", "y" }; 

        static std::vector<std::string> Vowel = 
            { "a", "e", "i", "o", "u" }; 

        static std::vector<std::string> DoubleVowel = 
            { "ae", "au", "ea", "ey", "ie", "io", "oe", "oi", "oo", "ou", "ue", 
              "ui", "ya", "yo" };
    }

    namespace address
    {
        static std::vector<std::string> PlaceTypes = 
            { "house", "cottage", "studio", "residence", "farm", "retreat", 
              "manor", "castle" };

        static std::vector<std::string> AreaTypes = 
            { "square", "lane", "point", "avenue", "street", "close", "drive", 
              "crescent", "walk", "park", "circle", "prefecture", "district" };

        #include "ukTowns.h.inl"
    }

    typedef std::vector<std::vector<std::string>> NameTemplate;

    class NameGenerator
    {
    public:
        // generate a random single name from the available templates
        std::string GenerateName();
        // use the phonemes above
        void AddNameTemplate(NameTemplate nameTemplate);
        void ClearNameTemplates();
        // also clears the current name templates
        void PushTemplateStack();
        void PopTemplateStack();

        void AddExampleNameTemplates();
    private:

        std::vector<NameTemplate> m_nameTemplates;
        std::vector<std::vector<NameTemplate>> m_nameTemplateStack;
    };

    class PlaceNameGenerator
    {
    public:
        std::string Generate1stLine();
        std::string Generate2ndLine();
        std::string Generate3rdLine();
    };
}
}
